"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _link = _interopRequireDefault(require("next/link"));

var _router = _interopRequireDefault(require("next/router"));

var _url = require("url");

var DataLink = /*#__PURE__*/function (_Link) {
  (0, _inherits2["default"])(DataLink, _Link);

  function DataLink() {
    (0, _classCallCheck2["default"])(this, DataLink);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(DataLink).apply(this, arguments));
  }

  (0, _createClass2["default"])(DataLink, [{
    key: "prefetch",
    value: function () {
      var _prefetch = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var href, _ref, query, parsedHref, Component, ctx;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(typeof window === "undefined")) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                href = this.props.href;
                _ref = typeof href !== "string" ? href : (0, _url.parse)(href, true), query = _ref.query;
                parsedHref = (0, _url.resolve)(window.location.pathname, (0, _url.format)(href));
                _context.next = 7;
                return _router["default"].prefetch(parsedHref);

              case 7:
                _context.t0 = _context.sent;

                if (_context.t0) {
                  _context.next = 10;
                  break;
                }

                _context.t0 = {};

              case 10:
                Component = _context.t0;

                if (typeof Component.getInitialProps === "function") {
                  ctx = {
                    pathname: href,
                    query: query,
                    isVirtualCall: true
                  };
                  Component.getInitialProps(ctx);
                }

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function prefetch() {
        return _prefetch.apply(this, arguments);
      }

      return prefetch;
    }()
  }]);
  return DataLink;
}(_link["default"]);

exports["default"] = DataLink;